/*=============================================================================/
/                                                                              /
/                                POXtH[}bg                               /
/                                                                              /
/                         Palette Operator PPI-Plugin SDK                      /
/             Copyright (C)2005-2006 Advangate. All rights reserved.           /
/------------------------------------------------------------------------------/
/ POXt@CtH[}bg\                                                  /
/                                                /
/       POXVOl`                                                    /
/         PoxSig     (4oCg)     POXwb_  PoxHead (132oCg)      /
/                                              /
/       POX摜f[^                                              /
/         PoxPict  (128oCg)                                         /
/                                              /
/       pbg摜                                                   /
/         PoxPalData[]                                                   /
/         pbgf[^                  POX摜f[^                /
/         PoxImgData[]                        ef[^̓ItZbgAh /
/         C[Wf[^                      XŃNĂB     /
/                                                                        /
/         CAEg͎R                                             /
/       `                      `                                           /
/                                                                        /
/                                                /
/=============================================================================*/
#ifndef	_POXFORMAT_H_
#define	_POXFORMAT_H_
#ifdef	__cplusplus
extern "C" {
#endif


/*=============================================================================/
/                                     ^`                                   /
/=============================================================================*/
#ifndef PALOPE_DEFINED_TYPES
#define PALOPE_DEFINED_TYPES
typedef	signed  char		Sint8;
typedef	unsigned char		Uint8;
typedef	short				Sint16;
typedef	unsigned short		Uint16;
typedef	int					Sint32;
typedef	unsigned int		Uint32;
typedef	__int64				Sint64;
typedef	unsigned __int64	Uint64;
typedef	float				Float32;
typedef	double				Float64;
#endif // PALOPE_DEFINED_TYPES


/*=============================================================================/
/                               POXVOl``                              /
/=============================================================================*/
#define	POXFMT_SPEC_VER		0x00010000					/* POXtH[}bgdlo[W (ver1.00.00) */
#define	POXFMT_SIG_INT		0x58504f50					/* VOl` "POPX" */

/* ---- POXVOl`\ ---- */
typedef struct {
	Uint32				SigVal;							/* VOl`l */
	Uint32				SpecVer;						/* POXdlo[W */
} PoxSig;


/*=============================================================================/
/                               POX摜f[^`                              /
/------------------------------------------------------------------------------/
/ POX摜f[^\                                                            /
/                                                                              /
/   POX摜f[^                             C[Wf[^             /
/                                          /
/   PoxPict       ImgData PoxImgData[0]            /
/                 PalData                        /
/             pbgf[^    PoxImgData[1]            /
/                                          /
/                             PoxPalData[0]         .                  /
/                                     .                  /
/                             PoxPalData[1]         .                  /
/                                          /
/                                   .         PoxImgData[MipMapLevCnt-1] /
/                                   .                    /
/                                   .                                      /
/                                                            /
/                             PoxPalData[PalBankCnt-1]                       /
/                                                            /
/                                                                              /
/   C[Wf[^                                                       /
/                                                            /
/   PoxImgData     ImgBuf              /
/    ImgBufDir         C[Wobt@          /
/                      ImgBufIdx        ------------------------------   /
/                                         POXIMGTP_DIRECT̃TCY        /
/                                          Width*Height*sizeof(PoxRGBA)    /
/                                                                          /
/                                         POXIMGTP_INDEX̃TCY         /
/                                          Width*Height*sizeof(PoxIDXCOL)    /
/                                            /
/                                                                              /
/   pbgf[^                                                       /
/                          /
/   PoxPalData     PalBuf        pbgobt@          /
/                       ------------------------------   /
/                                         obt@TCY                   /
/                                          PalColCnt*sizeof(PoxRGBA)       /
/                                            /
/                                                                              /
/------------------------------------------------------------------------------/
/ e|C^̓t@C擪̃ItZbgAhXłB                     /
/=============================================================================*/
/* -------- sNZJ[` -------- */
/* qfa`J[ */
typedef union {
	/* evfŃANZX */
	struct {
		Uint8	r;											/*  (Red) */
		Uint8	g;											/*  (Green) */
		Uint8	b;											/*  (Blue) */
		Uint8	a;											/* At@ (Alpha) */
	};
	/* 32rbgANZX */
	Uint32		abgr;										/* 32rbgŃANZXꍇ 0xAABBGGRR ̕ */
} PoxRGBA;
/* CfbNXJ[ */
typedef struct {
	Uint8		idx;										/* pbgCfbNXԍ */
	Uint8		_reserved_;									/* U[u (0) */
} PoxIDXCOL;

/* -------- C[W^Cv` -------- */
typedef enum {
	POXIMGTP_DIRECT,										/* _CNgJ[摜 */
	POXIMGTP_INDEX,											/* CfbNXJ[摜 */
} PoxImgType;

/* -------- C[Wf[^ -------- */
typedef struct {
	Uint32				Width;								/* C[W̕ */
	Uint32				Height;								/* C[W̍ */
	Uint32				BufSize;							/* ImgBuf Ɋmۂꂽobt@[e(oCg) */
	union {
		Uint8*			ImgBuf;								/* C[Wf[^̊i[ */
		PoxRGBA*		ImgBufDir;							/* _CNgJ[ŃANZX */
		PoxIDXCOL*		ImgBufIdx;							/* CfbNXJ[ŃANZX */
	};
	Uint32				_reserved_[4];						/* U[u (0) */
} PoxImgData;

/* -------- pbgf[^ -------- */
typedef struct {
	Uint32				BufSize;							/* PalBuf Ɋmۂꂽobt@[e(oCg) */
	PoxRGBA*			PalBuf;								/* pbgf[^̊i[ */
	Uint32				_reserved_[6];						/* U[u (0) */
} PoxPalData;

/* -------- POX摜f[^\́EtO` (PoxPict.Flag) -------- */
#define	POXPICT_FLG_ALPHA				(1<<0)				/* At@`lĂ */

/* -------- POX摜f[^ -------- */
typedef struct {
	Uint32				Flag;								/* tO (POXPICT_FLG_` Œ`ꂽl) */
	PoxRGBA				ColBitDepth;						/* Frbg[x (r,g,b:e1`8 / a:0`8) */
	/* C[W */
	Uint8				Type;								/* C[W^Cv (PoxImgType) */
	Uint8				_reserved_[3];						/* U[u (0) */
	Uint32				MipMapLevCnt;						/* ~bv}bvx(C[W) */
	PoxImgData* 		ImgData;							/* C[Wf[^ */
	/* pbg */
	Uint32				PalBankCnt;							/* pbgoN */
	Uint32				PalColCnt;							/* Ppbg̃J[o^ */
	PoxPalData* 		PalData;							/* pbgf[^ */
	/* U[u (0) */
	Uint32				_reserved2_[24];					/* U[u (0) */
} PoxPict;


/*=============================================================================/
/                                 POXwb_`                                /
/=============================================================================*/
/* ---- POXwb_\ ---- */
typedef struct {
	PoxSig				Sig;								/* POXVOl` */
	PoxPict				Pict;								/* POX摜f[^ */
} PoxHead;






#ifdef	__cplusplus
}
#endif	/* __cplusplus */
#endif	/* _POXFORMAT_H_ */
/* ---------------- EOF ---------------- */
