/*=============================================================================/
/                                                                              /
/                           PPIvOCETvQ                          /
/                                                                              /
/                         Palette Operator PPI-Plugin SDK                      /
/             Copyright (C)2005-2006 Advangate. All rights reserved.           /
/------------------------------------------------------------------------------/
/ TvQ                                                                 /
/      FXȋ@\TvB                                          /
/      ̃pbgoNA~bv}bvɑΉB                              /
/      S̃vOCvV[WB                                    /
/      (VOl`݈̂ႤQ̃tH[}bgp̂S̃vOCvV[W /
/      Ă)                                                             /
/      pbgt@Cipbĝ݉摜jɑΉB                            /
/      AoEg\ɑΉB                                                    /
/      SM22tH[}bg̕ۑpIvVݒ_CAOB                /
/      IvVݒl̎擾ƃZbgɑΉB                                  /
/------------------------------------------------------------------------------/
/ XV                                                                   /
/    Ver 1.01                                                                  /
/       EIvVݒ_CAOɁuݒl1v,uݒl2v̂Q̐ݒlZb/
/         gRg[ǉB                                           /
/       Euݒlóv@\ɑΉǉAIvVݒlzXg /
/         AvP[VƂ̊ԂŎ󂯓nł悤ɂB                   /
/    Ver 1.00                                                                  /
/       EVK쐬                                                             /
/=============================================================================*/
#include <memory.h>
#include <stdio.h>
#include "..\..\..\include\PalOpePlgin.h"
#include "resource.h"


/*=============================================================================/
/                                  vg^Cv                                /
/=============================================================================*/
static BOOL fileLoadChkSupport(PpiPrcContext* prctx, PpiFileInf* fileinf, Uint32 sig);
static PpiErr fileLoadExec(PpiPrcContext* prctx, PpiFileInf* fileinf, Uint32 sig);
static PpiErr fileSaveExec(PpiPrcContext* prctx, PpiFileInf* fileinf, Uint32 sig);
static BOOL CALLBACK dlgProc(HWND hDlg, UINT uMes, WPARAM wParam, LPARAM lParam);


/*=============================================================================/
/                            t@CtH[}bg`                          /
/------------------------------------------------------------------------------/
/ t@CtH[}bg\                                                   /
/                                                  /
/      wb_                                                              /
/        FmtSmp2   (16oCg)                                              /
/                                                  /
/      pbgJ[f[^     <-- CfbNXJ[̏ꍇ̂ݑ݂B /
/        oN[0]                                                         /
/       - - - - - - - - - - -                                              /
/      pbgJ[f[^                                                /
/        oN[1]                                                         /
/       - - - - - - - - - - -                                              /
/                 .                                                        /
/                 .                                                        /
/                 .                                                        /
/       - - - - - - - - - - -                                              /
/      pbgJ[f[^                                                /
/        oN[PalBnkNum-1]                                               /
/                                                  /
/      摜f[^               <-- upbĝ݉摜v̏ꍇ݂͑Ȃ /
/        ~bv}bv[0]                                                   /
/       - - - - - - - - - - -                                              /
/      摜f[^                                                          /
/        ~bv}bv[1]                                                   /
/       - - - - - - - - - - -                                              /
/                 .                                                        /
/                 .                                                        /
/                 .                                                        /
/       - - - - - - - - - - -                                              /
/      摜f[^                                                          /
/        ~bv}bv[MipMapNum-1]                                           /
/                                                  /
/                                                                              /
/ 摜f[^tH[}bg                                                     /
/                                                    /
/       摜TCYwb_                                                   /
/         ImgSize  (4oCg)                                               /
/                                                    /
/       摜̃sNZf[^                                               /
/                                                                          /
/       `                      `                                             /
/                                                                          /
/                                                                          /
/                                                    /
/=============================================================================*/
#define		FMTSMP2_SIG1_VAL		(0x31324d53)			/* VOl` "SM21" */
#define		FMTSMP2_SIG2_VAL		(0x32324d53)			/* VOl` "SM22" */

typedef struct {
	Uint32		Sig;										/* VOl`l */
	Uint8		Type;										/* 摜^Cv 0:_CNgJ[  1:CfbNXJ[ */
	Uint8		Alpha;										/* At@`lLȏꍇ 1 */
	Uint16		PalColNum;									/* CfbNXJ[̏ꍇ̃pbgJ[ */
	Uint16		Width;										/* 摜TCY: (MipMapx0̉摜TCY) */
	Uint16		Height;										/* 摜TCY: (MipMapx0̉摜TCY)  */
	Uint16		PalBnkNum;									/* pbgoN */
	Uint16		MipMapNum;									/* ~bv}bv摜 (0̎́upbĝ݉摜v) */
} FmtSmp2;

typedef struct {
	Uint16		Width;										/* 摜TCYi) */
	Uint16		Height;										/* 摜TCYi) */
} ImgSize;


/*=============================================================================/
/                         SM22pۑIvVݒl`                       /
/=============================================================================*/
#define		SM22_SVOPT_STRVAL_MAX		(PSIO_STRING_MAX)	/* l̍ő啶 */

/* SM22pۑIvVݒl\ */
typedef struct {
	BOOL		BoolVal;									/* BOOLl (ݒl1) */
	char		StringVal[SM22_SVOPT_STRVAL_MAX];			/* l (ݒl2) */
} SM22SaveOpt;

/* SM22pۑIvVݒl̎ */
SM22SaveOpt	SM22SvOpt;


/*=============================================================================/
/                              vOCf[^                            /
/=============================================================================*/
/* -------- vV[WID` -------- */
#define PRCID_LOAD_SM21		0									/* SM21[hpvV[WID */
#define PRCID_SAVE_SM21		1									/* SM21Z[upvV[WID */
#define PRCID_LOAD_SM22		2									/* SM22[hpvV[WID */
#define PRCID_SAVE_SM22		3									/* SM22Z[upvV[WID */

/* -------- vOCf[^ -------- */
PpiPluginInfoData plginInfDt = 
	PLGIFDATA(
		"PPIvOCETvQ",						/* vOC */
		"Copyright (C) 2005-2006 Advangate. Ver 1.01"		/* o[WRs[Cg\p */
	);

/* -------- vV[Wf[^ -------- */
PpiProcInfoData procInfDt[] = {
	/* SM21[hpvV[W */
	PRCIFDATA_LOAD(
		PRCID_LOAD_SM21,									/* vV[WIDԍ */
		"SM21tH[}bg[_",							/* vV[W */
		PRCIDCAPS_IMAGE_DIR | PRCIDCAPS_IMAGE_IDX			/* \̓tO (PRCIDCAPS_` Œ`ꂽl) */
		 | PRCIDCAPS_ALPHA | PRCIDCAPS_ONLY_PAL | PRCIDCAPS_PALBANK | PRCIDCAPS_MIPMAP,
		"vOCTvSM21",							/* tB^[ */
		"*.sm21"											/* tB^[p^[ */
	),
	/* SM21Z[upvV[W */
	PRCIFDATA_SAVE(
		PRCID_SAVE_SM21,									/* vV[WIDԍ */
		"SM21tH[}bgZ[o",							/* vV[W */
		PRCIDCAPS_IMAGE_DIR | PRCIDCAPS_IMAGE_IDX			/* \̓tO (PRCIDCAPS_` Œ`ꂽl) */
		 | PRCIDCAPS_ALPHA | PRCIDCAPS_ONLY_PAL | PRCIDCAPS_PALBANK | PRCIDCAPS_MIPMAP,
		"vOCTvSM21",							/* tB^[ */
		"*.sm21"											/* tB^[p^[ */
	),
	
	/* SM22[hpvV[W */
	PRCIFDATA_LOAD(
		PRCID_LOAD_SM22,									/* vV[WIDԍ */
		"SM22tH[}bg[_",							/* vV[W */
		PRCIDCAPS_IMAGE_DIR | PRCIDCAPS_IMAGE_IDX			/* \̓tO (PRCIDCAPS_` Œ`ꂽl) */
		 | PRCIDCAPS_ALPHA | PRCIDCAPS_ONLY_PAL | PRCIDCAPS_PALBANK | PRCIDCAPS_MIPMAP,
		"vOCTvSM22",							/* tB^[ */
		"*.sm22"											/* tB^[p^[ */
	),
	/* SM22Z[upvV[W */
	PRCIFDATA_SAVE(
		PRCID_SAVE_SM22,									/* vV[WIDԍ */
		"SM22tH[}bgZ[o",							/* vV[W */
		PRCIDCAPS_IMAGE_DIR | PRCIDCAPS_IMAGE_IDX			/* \̓tO (PRCIDCAPS_` Œ`ꂽl) */
		 | PRCIDCAPS_ALPHA | PRCIDCAPS_ONLY_PAL | PRCIDCAPS_PALBANK | PRCIDCAPS_MIPMAP | PRCIDCAPS_OPTIONS,
		"vOCTvSM22",							/* tB^[ */
		"*.sm22"											/* tB^[p^[ */
	),
	
	/* I[ */
	PRCIFDATA_TERM()
};


/*=============================================================================/
/                                ckkC                              /
/------------------------------------------------------------------------------/
/ DLL̃Gg|CgB                                                      /
/=============================================================================*/
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
	return TRUE;
}


/*=============================================================================/
/                                vOC̐ڑ                              /
/------------------------------------------------------------------------------/
/ prm.                                                                         /
/       PpiPlgContext* plgctx       : vOCReLXg                   /
/       PpiPluginInfoData** plgifdt : vOCf[^i[               /
/       PpiProcInfoData** prcifdt   : vV[Wf[^i[             /
/ ret.                                                                         /
/       BOOL     : TRUE ̏ꍇ͐ڑBFALSE ̏ꍇ͐ڑsB             /
/------------------------------------------------------------------------------/
/ vOC̊ezXgAvP[VɓnAvOCƐڑsB   /
/ FALSE ԂƃzXgł̃vOCgpȂB                         /
/=============================================================================*/
PPIEXPT BOOL PPIAPI PpiConnectPlugin(PpiPlgContext* plgctx, PpiPluginInfoData** plgifdt, PpiProcInfoData** prcifdt)
{
	*plgifdt = &plginInfDt;									/* vOCf[^ */
	*prcifdt = procInfDt;									/* vV[Wf[^ */

	return TRUE;
}


/*=============================================================================/
/                                vOC̐ؒf                              /
/------------------------------------------------------------------------------/
/ prm.                                                                         /
/       PpiPlgContext* plgctx       : vOCReLXg                   /
/------------------------------------------------------------------------------/
/ vOCƂ̐ڑؒfOɌĂяoB                               /
/=============================================================================*/
//PPIEXPT void PPIAPI PpiDisconnectPlugin(PpiPlgContext* plgctx)
//{
//}


/*=============================================================================/
/                               vV[W̐ڑ                             /
/------------------------------------------------------------------------------/
/ prm.                                                                         /
/       PpiPrcContext* prctx        : vV[WReLXg                 /
/ ret.                                                                         /
/       BOOL     : TRUE ̏ꍇ͐ڑBFALSE ̏ꍇ͐ڑsB             /
/------------------------------------------------------------------------------/
/ vV[WƂ̐ڑɌĂяoBKvȂ΃vV[W̏sB /
/ FALSE ԂꍇÃvV[WgpȂB                           /
/=============================================================================*/
PPIEXPT BOOL PPIAPI PpiConnectProc(PpiPrcContext* prctx)
{
	/* IvVݒl */
	if(prctx->ProcID == PRCID_SAVE_SM22){
		/* SM22pۑIvVݒl */
		ZeroMemory(&SM22SvOpt, sizeof(SM22SvOpt));
	}

	return TRUE;
}


/*=============================================================================/
/                               vV[W̐ؒf                             /
/------------------------------------------------------------------------------/
/ prm.                                                                         /
/       PpiPrcContext* prctx        : vV[WReLXg                 /
/------------------------------------------------------------------------------/
/ vV[WƂ̐ڑؒfOɌĂяoB                             /
/=============================================================================*/
//PPIEXPT void PPIAPI PpiDisconnectProc(PpiPrcContext* prctx)
//{
//}


/*=============================================================================/
/                                  AoEg\                                /
/------------------------------------------------------------------------------/
/ prm.                                                                         /
/       PpiPlgContext* plgctx       : vOCReLXg                   /
/------------------------------------------------------------------------------/
/ o[WRs[Cg\_CAO\鏈B               /
/ svȏꍇ͊֐̂̎sȂ悤ɂB                             /
/=============================================================================*/
PPIEXPT void PPIAPI PpiDispAbout(PpiPlgContext* plgctx)
{
	/* ȗ̂߂ɃbZ[W{bNXgpĕ\ */
	MessageBox(plgctx->WndHdl, plginInfDt.PluginVerCpy, plginInfDt.PluginName, MB_OK);
}


/*=============================================================================/
/                        t@C[hp̃IvVݒ                      /
/------------------------------------------------------------------------------/
/ prm.                                                                         /
/       PpiPrcContext* prctx        : vV[WReLXg                 /
/       PpiFileInf* fileinf         : t@Cp[^                   /
/ ret.                                                                         /
/       PpiErr   : G[ԍ                                                  /
/------------------------------------------------------------------------------/
/ t@C[hvV[WŃt@C̃[hOɃIvVݒsB       /
/=============================================================================*/
//PPIEXPT PpiErr PPIAPI PpiFileLoadOptions(PpiPrcContext* prctx, PpiFileInf* fileinf)
//{
//	return PPIERR_OK;
//}


/*=============================================================================/
/                         t@C[h̑Ή`FbN                       /
/------------------------------------------------------------------------------/
/ prm.                                                                         /
/       PpiPrcContext* prctx        : vV[WReLXg                 /
/       PpiFileInf* fileinf         : t@Cp[^                   /
/ ret.                                                                         /
/       BOOL     : TRUE ̏ꍇ͑Ή\BFALSE ̏ꍇ͑ΉȂB           /
/------------------------------------------------------------------------------/
/ fileinf Ŏꂽt@C͑Ήt@C`FbNsB               /
/ Ήꍇ TRUE ԂAΉłȂꍇ FALSE ԂB                /
/=============================================================================*/
PPIEXPT BOOL PPIAPI PpiFileLoadChkSupport(PpiPrcContext* prctx, PpiFileInf* fileinf)
{
	/* vOvV[Wɕ򂷂 */
	if(prctx->ProcID == PRCID_LOAD_SM21){
		/* "SM21"p */
		return fileLoadChkSupport(prctx, fileinf, FMTSMP2_SIG1_VAL);
	} else if(prctx->ProcID == PRCID_LOAD_SM22){
		/* "SM22"p */
		return fileLoadChkSupport(prctx, fileinf, FMTSMP2_SIG2_VAL);
	}

	return FALSE;
}


/*=============================================================================/
/                  t@C[h̃t@C̓ǂݏo                /
/------------------------------------------------------------------------------/
/ prm.                                                                         /
/       PpiPrcContext* prctx        : vV[WReLXg                 /
/       PpiFileInf* fileinf         : t@Cp[^                   /
/ ret.                                                                         /
/       PpiErr   : G[ԍ                                                  /
/------------------------------------------------------------------------------/
/ t@C̓ǂݏo̖{́B                                           /
/ Ńt@Cf[^ǂݏozXg摜f[^Ɋi[B               /
/ [hꍇ PPIERR_OK ԂAG[Lꍇ͂ȊOԂB  /
/=============================================================================*/
PPIEXPT PpiErr PPIAPI PpiFileLoadExec(PpiPrcContext* prctx, PpiFileInf* fileinf)
{
	/* vOvV[Wɕ򂷂 */
	if(prctx->ProcID == PRCID_LOAD_SM21){
		/* "SM21"p */
		return fileLoadExec(prctx, fileinf, FMTSMP2_SIG1_VAL);
	} else if(prctx->ProcID == PRCID_LOAD_SM22){
		/* "SM22"p */
		return fileLoadExec(prctx, fileinf, FMTSMP2_SIG2_VAL);
	}

	return PPIERR_ERROR;
}


/*=============================================================================/
/                        t@CZ[up̃IvVݒ                      /
/------------------------------------------------------------------------------/
/ prm.                                                                         /
/       PpiPrcContext* prctx        : vV[WReLXg                 /
/       PpiFileInf* fileinf         : t@Cp[^                   /
/ ret.                                                                         /
/       PpiErr   : G[ԍ                                                  /
/------------------------------------------------------------------------------/
/ t@CZ[uvV[WŃt@C̃Z[uOɃIvVݒsB       /
/=============================================================================*/
PPIEXPT PpiErr PPIAPI PpiFileSaveOptions(PpiPrcContext* prctx, PpiFileInf* fileinf)
{
	/* "SM22"tH[}bg̏ꍇɂ̂݃IvV_CAOJ */
	if(prctx->ProcID == PRCID_SAVE_SM22){
		/* uSM22tH[}bgۑݒv_CAO{bNXJ */
		if(DialogBox(prctx->PlgCtx->InstHdl, "SM22SaveOpt", prctx->PlgCtx->WndHdl, dlgProc) == FALSE){
			/* LZꂽ */
			return PPIERR_CANCELED;
		}
		return PPIERR_OK;
	}

	return PPIERR_ERROR;
}


/*=============================================================================/
/                      t@CZ[ũt@C֕ۑ                    /
/------------------------------------------------------------------------------/
/ prm.                                                                         /
/       PpiPrcContext* prctx        : vV[WReLXg                 /
/       PpiFileInf* fileinf         : t@Cp[^                   /
/ ret.                                                                         /
/       PpiErr   : G[ԍ                                                  /
/------------------------------------------------------------------------------/
/ t@Cւ̕ۑ̖{́B                                                 /
/ ŃzXg摜f[^̏t@CɕۑB                           /
/ Z[uꍇ PPIERR_OK ԂAG[Lꍇ͂ȊOԂB  /
/=============================================================================*/
PPIEXPT PpiErr PPIAPI PpiFileSaveExec(PpiPrcContext* prctx, PpiFileInf* fileinf)
{
	/* vOvV[Wɕ򂷂 */
	if(prctx->ProcID == PRCID_SAVE_SM21){
		/* "SM21"p */
		return fileSaveExec(prctx, fileinf, FMTSMP2_SIG1_VAL);
	} else if(prctx->ProcID == PRCID_SAVE_SM22){
		/* "SM22"p */
		return fileSaveExec(prctx, fileinf, FMTSMP2_SIG2_VAL);
	}

	return PPIERR_ERROR;
}







/*-----------------------------------------------------------------------------/
/                         t@C[h̑Ή`FbN                       /
/-----------------------------------------------------------------------------*/
static BOOL fileLoadChkSupport(PpiPrcContext* prctx, PpiFileInf* fileinf, Uint32 sig)
{
	const FmtSmp2*	header = (FmtSmp2*)(fileinf->FileHeadBuf);

	/* VOl`̃`FbN */
	if(header->Sig != sig){
		return FALSE;
	}

	/* Ή摜^Cv`FbN */
	if((header->Type != 0) && (header->Type != 1)){
		return FALSE;
	}

	/* Ή\ȃtH[}bg */
	return TRUE;
}


/*-----------------------------------------------------------------------------/
/                  t@C[h̃t@C̓ǂݏo                /
/-----------------------------------------------------------------------------*/
static PpiErr fileLoadExec(PpiPrcContext* prctx, PpiFileInf* fileinf, Uint32 sig)
{
	PpiErr res;
	FILE* fp = NULL;
	PpiHostPict* php = &prctx->HostPict;
	FmtSmp2	header;
	Uint32 i, size;

	Uint32 flg;
	PpiImgType type;
	Uint32 w;
	Uint32 h;
	Uint32 mmc;
	Uint32 palbnkc;
	Uint32 palcolc;

	/* -------- t@CJ -------- */
	if((fp = fopen(fileinf->FileName, "rb")) == NULL){
		/* t@CJȂ */
		res = PPIERR_FILE_ERR;
		goto __FINAL_POINT;
	}
	/* vOX */
	if(PpiHaProgress(prctx, 0)){
		/* [U[ɂLZ */
		res = PPIERR_CANCELED;
		goto __FINAL_POINT;
	}

	/* -------- wb_ǂݏo -------- */
	if(fread(&header, 1, sizeof(header), fp) != sizeof(header)){
		/* wb_̓ǂݏos */
		res = PPIERR_FILE_ERR;
		goto __FINAL_POINT;
	}
	/* pbgJ[킩`FbN */
	if(header.Type == 1){									/* CfbNXJ[摜̏ꍇ */
		if(header.PalColNum == 0){
			/* pbgJ[݂Ȃ */
			res = PPIERR_DATA_BROKEN;
			goto __FINAL_POINT;
		}
	}
	/* 摜TCY킩`FbN */
	if(header.MipMapNum){
		if((header.Width == 0) || (header.Height == 0)){
			res = PPIERR_DATA_BROKEN;
			goto __FINAL_POINT;
		}
	}
	/* upbĝ݉摜v̏ꍇُ̈`FbN */
	if(header.MipMapNum == 0){
		/* CfbNXJ[̕KvL */
		if(header.Type != 1){
			res = PPIERR_DATA_BROKEN;
			goto __FINAL_POINT;
		}
	}

	/* -------- zXg摜쐬 -------- */
	/* p[^߂ */
	flg = 0;
	type = PPIIMGTP_DIRECT;
	w = header.Width;
	h = header.Height;
	mmc = header.MipMapNum;
	palbnkc = 0;
	palcolc = 0;
	if(header.Alpha){
		/* At@`lĂ */
		flg |= PPIHSTIG_FLG_ALPHA;
	}
	if(header.Type == 1){
		/* CfbNXJ[摜 */
		type = PPIIMGTP_INDEX;
		palbnkc = header.PalBnkNum;
		palcolc = header.PalColNum;
	}
	/* zXg摜쐬 */
	res = PpiHaCreateHostPict(prctx, flg, type, w, h, mmc, palbnkc, palcolc);
	if(res != PPIERR_OK){
		/* zXg摜̍쐬Ɏs */
		goto __FINAL_POINT;
	}

	/* -------- pbg̓ǂݏo -------- */
	if(type == PPIIMGTP_INDEX){
		/* SpbgoN̓ǂݏo */
		Uint32 bnk;
		for(bnk = 0; bnk < php->PalBankCnt; bnk++){
			/* PoN̓ǂݏo */
			Uint8 col[4];
			PpiRGBA* pal = php->PalData[bnk].PalBuf;
			size = (header.Alpha)? 4 : 3;					/* PF̃TCY */
			for(i = 0; i < php->PalColCnt; i++, pal++){
				/* pbĝPFǂݏo */
				if(fread(col, 1, size, fp) != size){
					/* pbg̓ǂݏos */
					res = PPIERR_DATA_BROKEN;
					goto __FINAL_POINT;
				}
				/* PFi[ */
				pal->r = col[0];
				pal->g = col[1];
				pal->b = col[2];
				if(header.Alpha){
					pal->a = col[3];
				}
			}
		}
	}

	/* -------- 摜̓ǂݏo -------- */
	if(php->MipMapLevCnt){									/* 摜݂͑H */
		Uint32 mmlv, ttlh, cnth;
		/* S~bv}bv摜̍̍v߂(vOXp) */
		ttlh = 0;
		for(mmlv = 0; mmlv < php->MipMapLevCnt; mmlv++){
			ttlh += php->ImgData[mmlv].Height;
		}
		/* S~bv}bvx̉摜ǂݏo */
		cnth = 0;
		for(mmlv = 0; mmlv < php->MipMapLevCnt; mmlv++){
			/* 摜TCYwb_擾 */
			ImgSize imgsz;
			if(fread(&imgsz, 1, sizeof(ImgSize), fp) != sizeof(ImgSize)){
				/* 摜TCY̓ǂݏos */
				res = PPIERR_DATA_BROKEN;
				goto __FINAL_POINT;
			}
			/* 摜TCYwb_̃`FbN */
			if((imgsz.Width != php->ImgData[mmlv].Width) || (imgsz.Height != php->ImgData[mmlv].Height)){
				/* 摜TCYُ */
				res = PPIERR_DATA_BROKEN;
				goto __FINAL_POINT;
			}
			/* P̃~bv}bv摜̓ǂݏo */
			if(type == PPIIMGTP_DIRECT){
				/* _CNgJ[摜ǂݏo */
				PpiRGBA* img = php->ImgData[mmlv].ImgBufDir;
				size = (header.Alpha)? 4 : 3;				/* PsNZ̃TCY */
				for(i = 0; i < imgsz.Height; i++, cnth++){
					/* PCǂݏo */
					Uint8 pix[4];
					Uint32 x;
					for(x = 0; x < imgsz.Width; x++, img++){
						/* PsNZǂݏo */
						if(fread(pix, 1, size, fp) != size){
							/* 摜̓ǂݏos */
							res = PPIERR_DATA_BROKEN;
							goto __FINAL_POINT;
						}
						/* PsNZi[ */
						img->r = pix[0];
						img->g = pix[1];
						img->b = pix[2];
						if(header.Alpha){
							img->a = pix[3];
						}
					}
					/* vOX */
					if(PpiHaProgress(prctx, 100*cnth/ttlh)){
						/* [U[ɂLZ */
						res = PPIERR_CANCELED;
						goto __FINAL_POINT;
					}
				}
			} else {
				/* CfbNXJ[摜ǂݏo */
				PpiIDXCOL* img = php->ImgData[mmlv].ImgBufIdx;
				size = 1;											/* PsNZ̃TCY */
				for(i = 0; i < imgsz.Height; i++, cnth++){
					/* PCǂݏo */
					Uint8 pix[1];
					Uint32 x;
					for(x = 0; x < imgsz.Width; x++, img++){
						/* PsNZǂݏo */
						if(fread(pix, 1, size, fp) != size){
							/* 摜̓ǂݏos */
							res = PPIERR_DATA_BROKEN;
							goto __FINAL_POINT;
						}
						/* PsNZi[ */
						img->idx = pix[0];
					}
					/* vOX */
					if(PpiHaProgress(prctx, 100*cnth/ttlh)){
						/* [U[ɂLZ */
						res = PPIERR_CANCELED;
						goto __FINAL_POINT;
					}
				}
			}
		}
	}

	/* ---- ǂݏo ---- */
	PpiHaProgress(prctx, 100);
	res = PPIERR_OK;

	/* -------- I -------- */
__FINAL_POINT:
	if(fp){
		fclose(fp);
	}
	return res;
}


/*-----------------------------------------------------------------------------/
/                      t@CZ[ũt@C֕ۑ                    /
/-----------------------------------------------------------------------------*/
static PpiErr fileSaveExec(PpiPrcContext* prctx, PpiFileInf* fileinf, Uint32 sig)
{
	PpiErr res;
	FILE* fp = NULL;
	PpiHostPict* php = &prctx->HostPict;
	FmtSmp2	header;
	Uint32 i, size;

	/* -------- wb_쐬 -------- */
	memset(&header, 0, sizeof(header));
	header.Sig = sig;										/* VOl`Zbg */
	if(php->Type == PPIIMGTP_INDEX){
		/* CfbNXJ[摜̏ꍇ */
		header.Type = 1;									/* CfbNXJ[ */
		header.PalColNum = php->PalColCnt;					/* CfbNXJ[̏ꍇ̃pbgJ[ */
		header.PalBnkNum = php->PalBankCnt;					/* CfbNXJ[̏ꍇ̃pbgoN */
	}
	if(php->Flag & PPIHSTIG_FLG_ALPHA){
		header.Alpha = 1;									/* At@`l͗L */
	}
	header.MipMapNum = php->MipMapLevCnt;					/* ~bv}bv摜 */
	if(header.MipMapNum){
		/* xỎ摜TCYZbg */
		header.Width = php->ImgData[0].Width;
		header.Height = php->ImgData[0].Height;
	}

	/* -------- t@CJ -------- */
	if((fp = fopen(fileinf->FileName, "wb")) == NULL){
		/* t@CJȂ */
		res = PPIERR_FILE_ERR;
		goto __FINAL_POINT;
	}
	/* vOX */
	if(PpiHaProgress(prctx, 0)){
		/* [U[ɂLZ */
		res = PPIERR_CANCELED;
		goto __FINAL_POINT;
	}

	/* -------- wb_ۑ -------- */
	if(fwrite(&header, 1, sizeof(header), fp) != sizeof(header)){
		/* os */
		res = PPIERR_FILE_ERR;
		goto __FINAL_POINT;
	}

	/* -------- pbgۑ -------- */
	if(header.Type == 1){
		/* SpbgoN̕ۑ */
		Uint32 bnk;
		for(bnk = 0; bnk < php->PalBankCnt; bnk++){
			/* PoN̕ۑ */
			Uint8 col[4];
			const PpiRGBA* pal = php->PalData[bnk].PalBuf;
			size = (header.Alpha)? 4 : 3;						/* PF̃TCY */
			for(i = 0; i < php->PalColCnt; i++, pal++){
				/* pbĝPF擾 */
				col[0] = pal->r;
				col[1] = pal->g;
				col[2] = pal->b;
				if(header.Alpha){
					col[3] = pal->a;
				}
				/* pbĝPFۑ */
				if(fwrite(col, 1, size, fp) != size){
					/* os */
					res = PPIERR_FILE_ERR;
					goto __FINAL_POINT;
				}
			}
		}
	}

	/* -------- 摜ۑ -------- */
	if(php->MipMapLevCnt){									/* 摜݂͑H */
		Uint32 mmlv, ttlh, cnth;
		/* S~bv}bv摜̍̍v߂(vOXp) */
		ttlh = 0;
		for(mmlv = 0; mmlv < php->MipMapLevCnt; mmlv++){
			ttlh += php->ImgData[mmlv].Height;
		}
		/* S~bv}bvx̉摜ۑ */
		cnth = 0;
		for(mmlv = 0; mmlv < php->MipMapLevCnt; mmlv++){
			/* 摜TCYۑ */
			ImgSize imgsz;
			imgsz.Width = php->ImgData[mmlv].Width;
			imgsz.Height = php->ImgData[mmlv].Height;
			if(fwrite(&imgsz, 1, sizeof(ImgSize), fp) != sizeof(ImgSize)){
				/* 摜TCY̕ۑs */
				res = PPIERR_FILE_ERR;
				goto __FINAL_POINT;
			}
			/* P̃~bv}bv摜̓ǂݏo */
			if(header.Type == 0){
				/* _CNgJ[摜ۑ */
				const PpiRGBA* img = php->ImgData[mmlv].ImgBufDir;
				size = (header.Alpha)? 4 : 3;						/* PsNZ̃TCY */
				for(i = 0; i < imgsz.Height; i++, cnth++){
					/* PCۑ */
					Uint8 pix[4];
					Uint32 x;
					for(x = 0; x < imgsz.Width; x++, img++){
						/* PsNZ擾 */
						pix[0] = img->r;
						pix[1] = img->g;
						pix[2] = img->b;
						if(header.Alpha){
							pix[3] = img->a;
						}
						/* PsNZۑ */
						if(fwrite(pix, 1, size, fp) != size){
							/* 摜̕ۑɎs */
							res = PPIERR_FILE_ERR;
							goto __FINAL_POINT;
						}
					}
					/* vOX */
					if(PpiHaProgress(prctx, 100*cnth/ttlh)){
						/* [U[ɂLZ */
						res = PPIERR_CANCELED;
						goto __FINAL_POINT;
					}
				}
			} else {
				/* CfbNXJ[摜ۑ */
				const PpiIDXCOL* img = php->ImgData[mmlv].ImgBufIdx;
				size = 1;											/* PsNZ̃TCY */
				for(i = 0; i < imgsz.Height; i++, cnth++){
					/* PCۑ */
					Uint8 pix[1];
					Uint32 x;
					for(x = 0; x < imgsz.Width; x++, img++){
						/* PsNZ擾 */
						pix[0] = img->idx;
						/* PsNZۑ */
						if(fwrite(pix, 1, size, fp) != size){
							/* 摜̕ۑɎs */
							res = PPIERR_FILE_ERR;
							goto __FINAL_POINT;
						}
					}
					/* vOX */
					if(PpiHaProgress(prctx, 100*cnth/ttlh)){
						/* [U[ɂLZ */
						res = PPIERR_CANCELED;
						goto __FINAL_POINT;
					}
				}
			}
		}
	}

	/* ---- o ---- */
	PpiHaProgress(prctx, 100);
	res = PPIERR_OK;

	/* -------- I -------- */
__FINAL_POINT:
	if(fp){
		fclose(fp);
	}
	return res;
}


/*-----------------------------------------------------------------------------/
/                             _CAOvV[W                           /
/-----------------------------------------------------------------------------*/
static BOOL CALLBACK dlgProc(HWND hDlg, UINT uMes, WPARAM wParam, LPARAM lParam)
{
	switch(uMes){
		/* ---- _CAȌ ---- */
		case WM_INITDIALOG:
			/* SM22pۑIvVݒl_CAÕRg[ɐݒ */
			CheckDlgButton(hDlg, IDC_CHECK1, (SM22SvOpt.BoolVal)? BST_CHECKED : BST_UNCHECKED);	/* ݒl1 */
			SetDlgItemText(hDlg, IDC_EDIT1, SM22SvOpt.StringVal);								/* ݒl2 */
			return TRUE;
		/* ---- R}h ---- */
		case WM_COMMAND:
			switch(LOWORD(wParam)){
				/* ---- "OK"{^ ---- */
				case IDOK:
					/* _CAÕRg[SM22pۑIvVݒl擾 */
					SM22SvOpt.BoolVal = (IsDlgButtonChecked(hDlg, IDC_CHECK1) == BST_CHECKED);	/* ݒl1 */
					GetDlgItemText(hDlg, IDC_EDIT1, SM22SvOpt.StringVal, SM22_SVOPT_STRVAL_MAX); /* ݒl2 */
					/* _CAOI */
		        	EndDialog(hDlg, TRUE);
					return TRUE;
				/* ---- "LZ"{^ ---- */
				case IDCANCEL:
					/* _CAOI */
		        	EndDialog(hDlg, FALSE);
					return TRUE;
			}
			break;
	}

	return FALSE;
}


/*=============================================================================/
/                                  ݒl̎擾                                /
/------------------------------------------------------------------------------/
/ prm.                                                                         /
/       PpiPrcContext* prctx        : vV[WReLXg                 /
/       PpiStgIo*      sio          : ݒlo͏                         /
/ ret.                                                                         /
/       PpiErr   : G[ԍ                                                  /
/------------------------------------------------------------------------------/
/ zXgAvP[VnꂽvOC̐ݒl擾āAvOC /
/ ̐ݒlύXB                                                       /
/=============================================================================*/
PPIEXPT PpiErr PPIAPI PpiSettingGet(PpiPrcContext* prctx, PpiStgIo* sio)
{
	if(prctx->ProcID == PRCID_SAVE_SM22){
		/* ---- SM22pۑIvVݒl擾 ---- */
		/* ݒl1 */
		SM22SvOpt.BoolVal = PpiSioGetInt(prctx, sio, "BoolVal", SM22SvOpt.BoolVal);
		/* ݒl2 */
		PpiSioGetString(prctx, sio, "StringVal", SM22SvOpt.StringVal, SM22SvOpt.StringVal, SM22_SVOPT_STRVAL_MAX);
	}

	return PPIERR_OK;
}


/*=============================================================================/
;                                 ݒl̃Zbg                               /
/------------------------------------------------------------------------------/
/ prm.                                                                         /
/       PpiPrcContext* prctx        : vV[WReLXg                 /
/       PpiStgIo*      sio          : ݒlo͏                         /
/ ret.                                                                         /
/       PpiErr   : G[ԍ                                                  /
/------------------------------------------------------------------------------/
/ vOC̐ݒlzXgAvP[VɓnB                         /
/=============================================================================*/
PPIEXPT PpiErr PPIAPI PpiSettingSet(PpiPrcContext* prctx, PpiStgIo* sio)
{
	if(prctx->ProcID == PRCID_SAVE_SM22){
		/* ---- SM22pۑIvVݒlZbg ---- */
		/* ݒl1 */
		PpiSioSetInt(prctx, sio, "BoolVal", SM22SvOpt.BoolVal);
		/* ݒl2 */
		PpiSioSetString(prctx, sio, "StringVal", SM22SvOpt.StringVal);
	}

	return PPIERR_OK;
}






